using System.Security.Cryptography;
using System.Text;
using IdentityModel.Jwk;

namespace FitConnect.Encryption;

public class AspNetCoreEncryptor : IEncryptor {
    public string Encrypt(string plain, string key, out object? passOver) {
        var encryptionKey = new JsonWebKey(key);
        var rsa = encryptionKey.ToRsaPublicKey();

        passOver = rsa;

        var cipher = rsa.Encrypt(Encoding.UTF8.GetBytes(plain), RSAEncryptionPadding.OaepSHA512);
        return Convert.ToBase64String(cipher);
    }

    public string Decrypt(string cipher, string key, object? passOver = null) {
        var encryptionKey = new JsonWebKey(key);
        var rsa = encryptionKey.ToRsaPrivateKey();

        var plain = rsa.Decrypt(Convert.FromBase64String(cipher), RSAEncryptionPadding.OaepSHA512);
        return Encoding.UTF8.GetString(plain);
    }
}
