using System.Security.Cryptography.X509Certificates;

namespace FitConnect.Encryption;

public interface IEncryption {
    void ImportCertificate(X509Certificate2 cert);

    /// <summary>
    ///     Import a public key from a PEM file
    /// </summary>
    /// <param name="certificatePath"></param>
    /// <param name="password">Password for the certificate</param>
    /// <exception cref="ArgumentException"></exception>
    /// <exception cref="Exception"></exception>
    void ImportCertificate(string certificatePath, string password);

    byte[] DecryptData(byte[] data);
    string DecryptData(string data);

    byte[] ExportPublicKey();
    byte[] ExportPrivateKey();
    byte[] EncryptData(byte[] data);
    byte[] EncryptData(byte[] data, byte[] publicKey);
}
